<?php
class ApplicationException extends Exception {}

class TechnicalException extends ApplicationException {}

class BusinessException extends ApplicationException {}

function errorHandler ($code, $message, $file, $line)
{
	if ($code == E_STRICT)
		return;
	
	throw new TechnicalException ("{$code}:{$message} at {$file}:{$line}");
}

function exceptionHandler (Exception $e) 
{
	$class = get_class ($e);
	
	switch ($class)
	{
		case 'BusinessException':
		
			header('HTTP/1.1 500 Internal Server Error');
			header('Content-type: application/json');
			
			echo json_encode (array (
				'message' => $e->getMessage(),
				'technical_message' => ''
			));
		
		break;
		
		default:
		
			header('HTTP/1.1 500 Internal Server Error');
			header('Content-type: application/json');
			
			echo json_encode(array (
				'message' => 'Problemas técnicos no servidor!',
				'technical_message' => $e->getMessage()
			));
		
		break;
	}
}

set_error_handler ('errorHandler');
set_exception_handler ('exceptionHandler');