<?php
require 'error.php';
require 'config.inc.php';
require 'db.php';
require 'function.php';

try
{
	$update = isset ($_GET ['update']) && is_numeric ($_GET ['update']) ? (int) $_GET ['update'] : 0;
	
	if ($update < 0)
		throw new BusinessException ('Last update date is invalid!');
	
	$sql = "SELECT
				p.ID AS id,
				p.post_title AS question,
				p.post_content AS answer,
				c.id AS category_id
			FROM 8_posts AS p
			INNER JOIN 8_term_relationships AS cp ON cp.object_id = p.ID
			INNER JOIN
			(
				SELECT
					t.term_id AS id,
					t.name AS name
				FROM 8_terms AS t
				INNER JOIN 8_term_taxonomy AS tx ON t.term_id = tx.term_id
				WHERE tx.taxonomy = 'category'
			) AS c ON c.id = cp.term_taxonomy_id
			WHERE
				UNIX_TIMESTAMP (p.post_modified) >= :update";
	
	$stmt = $db->prepare ($sql);
	
	$stmt->execute (array (':update' => $update));
	
	$array = $stmt->fetchAll (PDO::FETCH_ASSOC);
	
	array_walk_recursive ($array, 'clean');
	
	echo json_encode ($array);
}
catch (PDOException $e)
{
    throw new TechnicalException ('Database communication error!', NULL, $e);
}